"use strict";
/**
 * @file quick.ts
 * @description
 * @author Dushan Ranasinghage
 * @copyright Copyright 2023 Dushan Ranasinghage, Alright Reserved.
 */
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Quick sort algorithm
 *
 * @name quickSort
 * @since  1.0.0
 * @access  public
 *
 * @property {T[]} arr Any type of array.
 */
function quickSort(arr) {
    if (arr.length <= 1) {
        return arr;
    }
    const pivotIndex = Math.floor(arr.length / 2);
    const pivot = arr[pivotIndex];
    const less = [];
    const equal = [];
    const greater = [];
    for (const element of arr) {
        if (element < pivot) {
            less.push(element);
        }
        else if (element === pivot) {
            equal.push(element);
        }
        else {
            greater.push(element);
        }
    }
    return [...quickSort(less), ...equal, ...quickSort(greater)];
}
exports.default = quickSort;
